diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/auth.c tin-2.6.5/src/auth.c
--- tin-2.6.4/src/auth.c	2024-12-06 11:20:43.000000000 +0100
+++ tin-2.6.5/src/auth.c	2025-12-07 06:46:18.034823859 +0100
@@ -3,11 +3,11 @@
  *  Module    : auth.c
  *  Author    : Dirk Nimmich <nimmich@muenster.de>
  *  Created   : 1997-04-05
- *  Updated   : 2024-11-25
+ *  Updated   : 2025-12-07
  *  Notes     : Routines to authenticate to a news server via NNTP.
  *              DON'T USE get_respcode() THROUGHOUT THIS CODE.
  *
- * Copyright (c) 1997-2025 Dirk Nimmich <nimmich@muenster.de>
+ * Copyright (c) 1997-2026 Dirk Nimmich <nimmich@muenster.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -60,8 +60,8 @@ static t_bool authinfo_plain(char *serve
 static char *prompt_for_authid(const char *authuser);
 static char *prompt_for_password(void);
 #	ifdef USE_GSASL
-	static int sasl_auth(char *user, char *pass);
-	static int do_authinfo_sasl(char *authuser, char *authpass);
+	static int sasl_auth(const char *user, const char *pass);
+	static int do_authinfo_sasl(const char *authuser, const char *authpass);
 	/* static int callback(Gsasl *ctx, Gsasl_session *sctx, Gsasl_property prop); */
 #	endif /* USE_GSASL */
 
@@ -141,7 +141,7 @@ read_newsauth_file(
 		/* allow ":port" suffix in .newsauth */
 		if ((p = strchr(line, ':')) != NULL) {
 			if (*line != '[' && strrchr(line, ':') == p) { /* exact 1 x ':' must be [name|ipv4]:port */
-				snprintf(hn, sizeof(hn), "%s:%u", server, nntp_tcp_port);
+				snprintf(hn, sizeof(hn), "%s:%u", server, (unsigned int) nntp_tcp_port);
 				if ((strcasecmp(line, hn)))
 					continue;
 			} else { /* "[ipv6]"[:port] */
@@ -152,7 +152,7 @@ read_newsauth_file(
 					}
 					if ((p = strchr(q, ':')) != NULL) {
 						if (p == q + 1) {
-							snprintf(hn, sizeof(hn), "[%s]:%u", server, nntp_tcp_port);
+							snprintf(hn, sizeof(hn), "[%s]:%u", server, (unsigned int) nntp_tcp_port);
 							if ((strcasecmp(line, hn)))
 								continue;
 						}
@@ -243,8 +243,12 @@ do_authinfo_user(
 #	endif /* DEBUG */
 	put_server(line, TRUE);
 	ret = get_only_respcode(line, sizeof(line));
-	if (!batch_mode || verbose || ret != OK_AUTH)
-		wait_message(2, (ret == OK_AUTH ? _(txt_authorization_ok) : _(txt_authorization_fail)), authuser);
+	if (ret != OK_AUTH)
+		wait_message(2, _(txt_authorization_fail), authuser);
+	else {
+		if (!batch_mode || verbose)
+			wait_message(0, _(txt_authorization_ok), authuser);
+	}
 	return ret;
 }
 
@@ -301,9 +305,9 @@ authinfo_plain(
 	 */
 	if (initialized && !changed && !already_failed) {
 #	ifdef USE_GSASL
-		if (nntp_caps.authinfo_sasl && *nntp_caps.sasl_mechs)
+		if (nntp_caps.authinfo_sasl && nntp_caps.sasl_mechs && *nntp_caps.sasl_mechs)
 			ret = do_authinfo_sasl(authusername, authpassword);
-		if (ret != OK_AUTH_SASL && ret != OK_AUTH)
+		if (ret != OK_AUTH_SASL && ret != OK_AUTH /* && ret != ERR_GOODBYE */)
 #	endif /* USE_GSASL */
 		{
 			if (nntp_caps.type != CAPABILITIES || nntp_caps.authinfo_user)
@@ -334,10 +338,10 @@ authinfo_plain(
 	if ((changed || !initialized) && !already_failed) {
 		if (read_newsauth_file(server, authuser, authpass)) {
 #	ifdef USE_GSASL
-			if (nntp_caps.authinfo_sasl && *nntp_caps.sasl_mechs)
+			if (nntp_caps.authinfo_sasl && nntp_caps.sasl_mechs && *nntp_caps.sasl_mechs)
 				ret = do_authinfo_sasl(authuser, authpass);
 
-			if (ret != OK_AUTH_SASL && ret != OK_AUTH)
+			if (ret != OK_AUTH_SASL && ret != OK_AUTH /* && ret != ERR_GOODBYE */)
 #	endif /* USE_GSASL */
 			{
 				if (force_auth_on_conn_open || nntp_caps.type != CAPABILITIES || (nntp_caps.type == CAPABILITIES && nntp_caps.authinfo_user))
@@ -380,7 +384,7 @@ authinfo_plain(
 			error_message(0, _(txt_auth_needed));
 			return (ret == OK_AUTH || ret == OK_AUTH_SASL);
 		}
-		if (nntp_caps.type != CAPABILITIES || (nntp_caps.type == CAPABILITIES && !nntp_caps.authinfo_state && ((nntp_caps.authinfo_sasl && *nntp_caps.sasl_mechs) || nntp_caps.authinfo_user))) {
+		if (nntp_caps.type != CAPABILITIES || (nntp_caps.type == CAPABILITIES && !nntp_caps.authinfo_state && ((nntp_caps.authinfo_sasl && nntp_caps.sasl_mechs && *nntp_caps.sasl_mechs) || nntp_caps.authinfo_user))) {
 			char *u, *p;
 
 			wait_message(0, _(txt_auth_needed));
@@ -402,7 +406,7 @@ authinfo_plain(
 			free(u);
 
 #	ifdef USE_GSASL
-			if (nntp_caps.authinfo_sasl && *nntp_caps.sasl_mechs)
+			if (nntp_caps.authinfo_sasl && nntp_caps.sasl_mechs && *nntp_caps.sasl_mechs)
 				ret = do_authinfo_sasl(authuser, authpass);
 			if (ret != OK_AUTH_SASL && ret != OK_AUTH)
 #	endif /* USE_GSASL */
@@ -505,12 +509,12 @@ authenticate(
 #	ifdef USE_GSASL
 static int
 do_authinfo_sasl(
-	char *authuser,
-	char *authpass)
+	const char *authuser,
+	const char *authpass)
 {
 	char *utf8user = NULL;
 	char *utf8pass = NULL;
-	int ret;
+	int r = -1;
 
 	if (authuser && *authuser)
 		utf8user = my_strdup(authuser);
@@ -521,47 +525,38 @@ do_authinfo_sasl(
 #		ifdef CHARSET_CONVERSION
 	/* RFC 4616 */
 	if (!IS_LOCAL_CHARSET("UTF-8")) {
-		char *cp;
-		int i, c = 0;
-		t_bool contains_8bit = FALSE;
-
+		int i;
 		/*
 		 * if authuser or authpass contains non ASCII-chars
 		 * convert both to UTF-8 even if this is a noop for
 		 * one of them
 		 */
 		if (utf8user && *utf8user) {
-			for (cp = utf8user; *cp; cp++) {
-				if (!isascii((unsigned char) *cp)) {
-					contains_8bit = TRUE;
+			for (i = 0; utf8user[i]; i++) {
+				if (!isascii((unsigned char) utf8user[i])) {
+					r = charset_name_to_num("UTF-8");
 					break;
 				}
 			}
 		}
-		if (!contains_8bit && utf8pass && *utf8pass) {
-			for (cp = utf8pass; *cp; cp++) {
-				if (!isascii((unsigned char) *cp)) {
-					contains_8bit = TRUE;
+
+		if (r == -1 && utf8pass && *utf8pass) {
+			for (i = 0; utf8pass[i]; i++) {
+				if (!isascii((unsigned char) utf8pass[i])) {
+					r = charset_name_to_num("UTF-8");
 					break;
 				}
 			}
 		}
-		if (contains_8bit) {
-			for (i = 0; txt_mime_charsets[i] != NULL; i++) {
-				if (!strcasecmp("UTF-8", txt_mime_charsets[i])) {
-					c = i;
-					break;
-				}
-			}
-			if (c == i) { /* should never fail */
-				if (utf8user && !buffer_to_network(&utf8user, c)) {
-					free(utf8user);
-					utf8user = my_strdup(authuser);
-				}
-				if (utf8pass && !buffer_to_network(&utf8pass, c)) {
-					free(utf8pass);
-					utf8pass = my_strdup(authpass);
-				}
+
+		if (r != -1) {
+			if (utf8user && !buffer_to_network(&utf8user, r)) {
+				free(utf8user);
+				utf8user = my_strdup(authuser);
+			}
+			if (utf8pass && !buffer_to_network(&utf8pass, r)) {
+				free(utf8pass);
+				utf8pass = my_strdup(authpass);
 			}
 		}
 	}
@@ -572,25 +567,42 @@ do_authinfo_sasl(
 		debug_print_file("NNTP", "do_authinfo_sasl(\"%s\", \"%s\")", BlankIfNull(authuser), BlankIfNull(authpass));
 #		endif /* DEBUG */
 
-	ret = sasl_auth(utf8user, utf8pass);
+	r = sasl_auth(utf8user, utf8pass);
 	FreeIfNeeded(utf8user);
 	FreeIfNeeded(utf8pass);
 
-	if (!batch_mode || verbose || (ret != OK_AUTH_SASL && ret != OK_AUTH))
-		wait_message(2, ((ret == OK_AUTH_SASL || ret == OK_AUTH) ? _(txt_authorization_ok) : _(txt_authorization_fail)), BlankIfNull(authuser));
-	return ret;
+	if (r != OK_AUTH_SASL && r != OK_AUTH)
+		wait_message(2, _(txt_authorization_fail), authuser);
+	else {
+		if (!batch_mode || verbose)
+			wait_message(0, _(txt_authorization_ok), authuser);
+	}
+	return r;
 }
 
 
 /*
- * TODO: add cyrus-sasl variant
- *       support more mechs
- *       callbacks
+ * TODO: - add cyrus-sasl variant
+ *       - support more mechs
+ *       - callbacks
+ *       - add configure check for return type of gsasl_property_set()
+ *         instead of hard coding GSASL_VERSION_NUMBER
+ *       - check for and use gsasl_property_free()?
  */
+#		if GSASL_VERSION_NUMBER >= 0x010b00
+#			define TIN_GSASL_PROP_SET(prop, data)  do { \
+					if (gsasl_property_set(session, prop, data) != GSASL_OK) \
+						goto sasl_done; \
+				} while (0)
+#		else
+#			define TIN_GSASL_PROP_SET(prop, data)  do { \
+					gsasl_property_set(session, prop, data); \
+				} while (0)
+#		endif /* GSASL_VERSION_NUMBER >= 0x010b00 */
 static int
 sasl_auth(
-	char *user,
-	char *pass)
+	const char *user,
+	const char *pass)
 {
 	Gsasl *ctx = NULL;
 	Gsasl_session *session = NULL;
@@ -619,25 +631,29 @@ sasl_auth(
 	sasl_prop = SASL_NEED_NONE;
 
 	/* figure out required properties - align mechs with nntplib.c:check_extensions() */
-	if (!strcasecmp(mech, "PLAIN") || !strcasecmp(mech, "LOGIN"))
+	if (!strcasecmp(mech, "PLAIN") /* || !strcasecmp(mech, "LOGIN")*/)
 		sasl_prop = (SASL_NEED_AUTHID | SASL_NEED_PASSWORD);
 	if (!strcasecmp(mech, "ANONYMOUS"))
 		sasl_prop = SASL_NEED_ANONYMOUS_TOKEN;
 
-	/* set required props  ... see also callback() */
-#if 0
-	if (user && (sasl_prop & SASL_NEED_AUTHZID)) /* authorization identity, usually not used with NNTP, but GSSAPI? */
-		gsasl_property_set(session, GSASL_AUTHZID, user);
-#endif /* 0 */
+	/* set required props; see also callback() */
+#		if 0
+	if (user && (sasl_prop & SASL_NEED_AUTHZID)) { /* authorization identity, usually not used with NNTP, but GSSAPI? */
+		TIN_GSASL_PROP_SET(GSASL_AUTHZID, user);
+	}
+#		endif /* 0 */
 
-	if (user && (sasl_prop & SASL_NEED_AUTHID))	/* authentication identity */
-		gsasl_property_set(session, GSASL_AUTHID, user);
+	if (user && (sasl_prop & SASL_NEED_AUTHID)) {	/* authentication identity */
+		TIN_GSASL_PROP_SET(GSASL_AUTHID, user);
+	}
 
-	if (pass && (sasl_prop & SASL_NEED_PASSWORD))	/* password of the authentication identity */
-		gsasl_property_set(session, GSASL_PASSWORD, pass);
+	if (pass && (sasl_prop & SASL_NEED_PASSWORD)) {	/* password of the authentication identity */
+		TIN_GSASL_PROP_SET(GSASL_PASSWORD, pass);
+	}
 
-	if (sasl_prop & SASL_NEED_ANONYMOUS_TOKEN)
-		gsasl_property_set(session, GSASL_ANONYMOUS_TOKEN, "dummy"); /* use a base64(randstr(len=whatever))?? */
+	if (sasl_prop & SASL_NEED_ANONYMOUS_TOKEN) {
+		TIN_GSASL_PROP_SET(GSASL_ANONYMOUS_TOKEN, "dummy");
+	}
 
 	/* authenticate */
 	snprintf(line, sizeof(line), "AUTHINFO SASL %s", mech);
@@ -674,9 +690,14 @@ sasl_done:
 
 	return ret;
 }
+#		undef TIN_GSASL_PROP_SET
 
 
-#if 0 /* prototype */
+#		if 0
+/*
+ * prototype; when we want to check gsasl_property_set()'s return
+ * value, use a wrapper like TIN_GSASL_PROP_SET() above.
+ */
 static int
 callback(
 	Gsasl *ctx,
@@ -685,22 +706,16 @@ callback(
 ) {
 	char *u, *p;
 	int rc = GSASL_NO_CALLBACK;
-	int c = 0, i = -1;
+	int c = -1;
 
 	(void) ctx;
-	if (!IS_LOCAL_CHARSET("UTF-8")) { /* charset conversion likely (we don't check for 7bit only) needed? */
-		for (i = 0; txt_mime_charsets[i] != NULL; i++) {
-			if (!strcasecmp("UTF-8", txt_mime_charsets[i])) {
-				c = i;
-				break;
-			}
-		}
-	}
+	if (!IS_LOCAL_CHARSET("UTF-8")) /* charset conversion likely (we don't check for 7bit only) needed? */
+		c = charset_name_to_num("UTF-8"); /* TODO: wrap into #ifdef CHARSET_CONVERSION ... */
 
 	switch (prop) {
 		case GSASL_AUTHID:
 			if ((u = prompt_for_authid(NULL)) != NULL) {
-				if (c == i) { /* convert to utf-8 */
+				if (c != -1) { /* convert to utf-8 */
 					char *u8 = my_strdup(u);
 
 					if (buffer_to_network(&u8, c))
@@ -719,7 +734,7 @@ callback(
 
 		case GSASL_PASSWORD:
 			if ((p = prompt_for_password()) != NULL) {
-				if (c == i) { /* convert to utf-8 */
+				if (c != -1) { /* convert to utf-8 */
 					char *p8 = my_strdup(p);
 
 					if (buffer_to_network(&p8, c))
@@ -736,13 +751,13 @@ callback(
 			}
 			break;
 
-		GSASL_ANONYMOUS_TOKEN:
+		case GSASL_ANONYMOUS_TOKEN:
 			gsasl_property_set(sctx, GSASL_ANONYMOUS_TOKEN, "dummy");
 			rc = GSASL_OK;
 			break;
 
-		GSASL_SERVICE:
-			gsasl_property_set(sctx, GSASL_SERVICE, "nntp");
+		case GSASL_SERVICE:
+			gsasl_property_set(sctx, GSASL_SERVICE, NNTP_TCP_NAME);
 			rc = GSASL_OK;
 			break;
 
@@ -751,18 +766,18 @@ callback(
 			rc = GSASL_OK;
 			break;
 
-#if 0
+#			if 0
 		case GSASL_AUTHZID:
 		case GSASL_PASSCODE:
 		case GSASL_PIN:
 		case GSASL_REALM:
-#endif /* 0 */
+#			endif /* 0 */
 		default: /* unhandled property */
 			break;
 	}
 	return rc;
 }
-#endif /* 0 */
+#		endif /* 0 */
 #	endif /* USE_GSASL */
 
 
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/charset.c tin-2.6.5/src/charset.c
--- tin-2.6.4/src/charset.c	2024-11-25 20:40:37.000000000 +0100
+++ tin-2.6.5/src/charset.c	2025-12-08 00:53:50.108065665 +0100
@@ -3,10 +3,10 @@
  *  Module    : charset.c
  *  Author    : M. Kuhn, T. Burmester
  *  Created   : 1993-12-10
- *  Updated   : 2024-11-25
+ *  Updated   : 2025-11-19
  *  Notes     : ISO to ascii charset conversion routines
  *
- * Copyright (c) 1993-2025 Markus Kuhn <mgk25@cl.cam.ac.uk>
+ * Copyright (c) 1993-2026 Markus Kuhn <mgk25@cl.cam.ac.uk>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -50,6 +50,7 @@
 #	endif /* USE_ICU_UCSDET */
 #endif /* CHARSET_CONVERSION */
 
+
 /*
  *  Table for the iso2asc conversion
  *  iso2asc  by  (unrza3@cd4680fs.rrze.uni-erlangen.de)
@@ -68,7 +69,7 @@
 
 static constext *const iso2asc[NUM_ISO_TABLES][256-ISO_EXTRA] =
 {
-	/* universal table for many languages */
+	/* 0 - universal table for many languages */
 	{
 	" ","!","c",SUB,SUB,"Y","|",SUB,"\"","(c)","a","<<","-","-","(R)","-",
 	" ","+/-","2","3","'","u","P",".",",","1","o",">>"," 1/4"," 1/2"," 3/4","?",
@@ -77,7 +78,7 @@ static constext *const iso2asc[NUM_ISO_T
 	"a","a","a","a","a","a","ae","c","e","e","e","e","i","i","i","i",
 	"d","n","o","o","o","o","o",":","o","u","u","u","u","y","th","y"
 	},
-	/* single-spacing universal table */
+	/* 1 - single-spacing universal table */
 	{
 	" ","!","c",SUB,SUB,"Y","|",SUB,"\"","c","a","<","-","-","R","-",
 	" ",SUB,"2","3","'","u","P",".",",","1","o",">",SUB,SUB,SUB,"?",
@@ -86,7 +87,7 @@ static constext *const iso2asc[NUM_ISO_T
 	"a","a","a","a","a","a","a","c","e","e","e","e","i","i","i","i",
 	"d","n","o","o","o","o","o",":","o","u","u","u","u","y","t","y"
 	},
-	/* table for Danish, Dutch, German, Norwegian and Swedish */
+	/* 2 - table for Danish, Dutch, German, Norwegian and Swedish */
 	{
 	" ","!","c",SUB,SUB,"Y","|",SUB,"\"","(c)","a","<<","-","-","(R)","-",
 	" ","+/-","2","3","'","u","P",".",",","1","o",">>"," 1/4"," 1/2"," 3/4","?",
@@ -95,7 +96,7 @@ static constext *const iso2asc[NUM_ISO_T
 	"a","a","a","a","ae","aa","ae","c","e","e","e","e","i","i","i","i",
 	"d","n","o","o","o","o","oe",":","oe","u","u","u","ue","y","th","ij"
 	},
-	/* table for Danish, Finnish, Norwegian and Swedish, ISO 646 variant */
+	/* 3 - table for Danish, Finnish, Norwegian and Swedish, ISO 646 variant */
 	{
 	" ","!","c",SUB,"$","Y","|",SUB,"\"","(c)","a","<<","-","-","(R)","-",
 	" ","+/-","2","3","'","u","P",".",",","1","o",">>"," 1/4"," 1/2"," 3/4","?",
@@ -104,7 +105,7 @@ static constext *const iso2asc[NUM_ISO_T
 	"a","a","a","a","{","}","{","c","e","`","e","e","i","i","i","i",
 	"d","n","o","o","o","o","|",":","|","u","u","u","~","y","th","y"
 	},
-	/* table with RFC 1345 codes in brackets */
+	/* 4 - table with RFC 1345 codes in brackets */
 	{
 	"[NS]","[!I]","[Ct]","[Pd]","[Cu]","[Ye]","[BB]","[SE]",
 	"[':]","[Co]","[-a]","[<<]","[NO]","[--]","[Rg]","['-]",
@@ -119,7 +120,7 @@ static constext *const iso2asc[NUM_ISO_T
 	"[d-]","[n?]","[o!]","[o']","[o>]","[o?]","[o:]","[-:]",
 	"[o/]","[u!]","[u']","[u>]","[u:]","[y']","[th]","[y:]"
 	},
-	/* table for printers that allow overstriking with backspace */
+	/* 5 - table for printers that allow overstriking with backspace */
 	{
 	" ","!","c\b|","L\b-","o\bX","Y\b=","|",SUB,
 	"\"","(c)","a\b_","<<","-\b,","-","(R)","-",
@@ -134,21 +135,6 @@ static constext *const iso2asc[NUM_ISO_T
 	"d\b-","n\b~","o\b`","o\b'","o\b^","o\b~","o\b\"","-\b:",
 	"o\b/","u\b`","u\b'","u\b^","u\b\"","y\b'","th","y\b\""
 	},
-	/* table for IBM PC character set (code page 437) */
-	{
-	"\377","\255","\233","\234",SUB,"\235","|","\25",
-	"\"","(c)","\246","\256","\252","-","(R)","-",
-	"\370","\361","\375","3","'","\346","\24","\371",
-	",","1","\247","\257","\254","\253"," 3/4","\250",
-	"A","A","A","A","\216","\217","\222","\200",
-	"E","\220","E","E","I","I","I","I",
-	"D","\245","O","O","O","O","\231","x",
-	"\355","U","U","U","\232","Y","T","\341",
-	"\205","\240","\203","a","\204","\206","\221","\207",
-	"\212","\202","\210","\211","\215","\241","\214","\213",
-	"d","\244","\225","\242","\223","o","\224","\366",
-	"\355","\227","\243","\226","\201","y","t","\230"
-	}
 };
 
 /*
@@ -158,6 +144,13 @@ static constext *const iso2asc[NUM_ISO_T
 #define TEX_SUBST	16
 #define SPACES		"                                                                                                         "
 
+/*
+ * - "i/"I (iuml/Iuml) are just in ISO-8859-{1,3,9,10,14,15,16}
+ *   but not in ISO-8859-{2,4}
+ * - "y (yuml) is "just" in ISO-8859-{1,9,14,15,16}
+ *
+ * - "S (sect) would be possible (all but ISO-8859-{5,6,11})
+ */
 static const char *const tex_from[TEX_SUBST] =
 {
 	"\"a", "\\\"a",
@@ -205,7 +198,7 @@ convert_iso2asc(
 				if ((asc - *asc_buffer) >= (int) *max_line_len) {
 					int offset = (int) (asc - *asc_buffer);
 					*max_line_len += 64;
-					*asc_buffer = my_realloc(*asc_buffer, *max_line_len);
+					*asc_buffer = my_realloc(*asc_buffer, *max_line_len + 1);
 					asc = *asc_buffer + offset;
 				}
 				++a;
@@ -265,7 +258,7 @@ convert_iso2asc(
 		if ((asc - *asc_buffer) >= (int) *max_line_len) {
 			int offset = (int) (asc - *asc_buffer);
 			*max_line_len += 64;
-			*asc_buffer = my_realloc(*asc_buffer, *max_line_len);
+			*asc_buffer = my_realloc(*asc_buffer, *max_line_len + 1);
 			asc = *asc_buffer + offset;
 		}
 	}
@@ -273,9 +266,12 @@ convert_iso2asc(
 }
 
 
+/*
+ * TODO: disallow "s at start of a word
+ */
 void
 convert_tex2iso(
-	char *from,
+	const char *from,
 	char *to)
 {
 	const char *tex_to[TEX_SUBST];
@@ -289,35 +285,33 @@ convert_tex2iso(
 	memset(tex_to, '\0', sizeof(tex_to));
 
 	/*
-	 * Charsets which have German umlauts incl. sharp s at the same
-	 * code position as ISO-8859-1
+	 * Charsets which have German umlauts incl. sharp s
+	 * at the same code position as ISO-8859-1
 	 * DEC-MCS, Windows-1252
 	 */
-	if (
-		!strcasecmp( /* ensure not to also match ISO-8859-{11,12} */
+	if (iso2asc_supported >= 0
+		/* ensure not to also match ISO-8859-{11,12} */
 #ifdef CHARSET_CONVERSION
-			tinrc.mm_local_charset
+		|| !strcasecmp(tinrc.mm_local_charset, "ISO-8859-1")
 #else
-			tinrc.mm_charset
+		|| !strcasecmp(tinrc.mm_charset, "ISO-8859-1")
 #endif /* CHARSET_CONVERSION */
-			, "ISO-8859-1") ||
-		IS_LOCAL_CHARSET("ISO-8859-2") ||
-		IS_LOCAL_CHARSET("ISO-8859-3") ||
-		IS_LOCAL_CHARSET("ISO-8859-4") ||
-		IS_LOCAL_CHARSET("ISO-8859-9") ||
-		IS_LOCAL_CHARSET("ISO-8859-10") ||
-		IS_LOCAL_CHARSET("ISO-8859-13") ||
-		IS_LOCAL_CHARSET("ISO-8859-14") ||
-		IS_LOCAL_CHARSET("ISO-8859-15") ||
-		IS_LOCAL_CHARSET("ISO-8859-16") ||
-		iso2asc_supported >= 0) {
+		|| IS_LOCAL_CHARSET("ISO-8859-2")
+		|| IS_LOCAL_CHARSET("ISO-8859-3")
+		|| IS_LOCAL_CHARSET("ISO-8859-4")
+		|| IS_LOCAL_CHARSET("ISO-8859-9")
+		|| IS_LOCAL_CHARSET("ISO-8859-10")
+		|| IS_LOCAL_CHARSET("ISO-8859-13")
+		|| IS_LOCAL_CHARSET("ISO-8859-14")
+		|| IS_LOCAL_CHARSET("ISO-8859-15")
+		|| IS_LOCAL_CHARSET("ISO-8859-16")) {
 		tex_to[1] = tex_to[0] = "\344";	/* auml */
 		tex_to[3] = tex_to[2] = "\366";	/* ouml */
 		tex_to[5] = tex_to[4] = "\374";	/* uuml */
 		tex_to[7] = tex_to[6] = "\304";	/* Auml */
 		tex_to[9] = tex_to[8] = "\326";	/* Ouml */
 		tex_to[11] = tex_to[10] = "\334";	/* Uuml */
-		tex_to[14] = tex_to[13] = tex_to[12] = "\337"; /* szlig */
+		tex_to[14] = tex_to[13] = tex_to[12] = "\337";	/* szlig */
 	} else if (IS_LOCAL_CHARSET("UTF-8")) { /* locale charset is UTF-8 */
 		tex_to[1] = tex_to[0] = "\303\244";	/* auml */
 		tex_to[3] = tex_to[2] = "\303\266";	/* ouml */
@@ -358,46 +352,6 @@ convert_tex2iso(
 
 
 /*
- * Check for German TeX encoding in file open on fp
- */
-t_bool
-is_art_tex_encoded(
-	FILE *fp)
-{
-	char *line;
-	int i, len;
-	t_bool body = FALSE;
-
-	rewind(fp);
-	while ((line = tin_fgets(fp, FALSE)) != NULL) {
-		if (!body) {
-			if (!*line)
-				body = TRUE;
-
-			continue;
-		}
-
-		i = 0;
-		while (line[i++] == ' ')
-			;	/* search for first non blank */
-
-		--i;
-		if (!isalnum((unsigned char) line[i]) && line[i] != '\"')
-			continue;	/* quoting char */
-
-		len = (int) strlen(line) - 1;
-		for (i = 1; i < len; i++) {
-			if (((line[i] == '\\') || (line[i] == '\"')) &&
-							(isalnum((unsigned char) line[i - 1])) &&
-							(isalnum((unsigned char) line[i + 1])))
-				return TRUE;
-		}
-	}
-	return FALSE;
-}
-
-
-/*
  * Replace all non printable characters by '?'
  */
 char *
@@ -425,6 +379,9 @@ convert_to_printable(
 #else
 	unsigned char *c;
 
+	if (IS_LOCAL_CHARSET("UTF-8"))
+		utf8_valid(buf);
+
 	for (c = (unsigned char *) buf; *c; c++) {
 		if (!my_isprint(*c) && !(keep_tab && *c == '\t'))
 			*c = '?';
@@ -469,22 +426,25 @@ charset_unsupported(
 	static const char *charsets[] = {
 		"csUnicode",	/* alias for ISO-10646-UCS-2 */
 		"csUCS4",		/* alias for ISO-10646-UCS-4 */
-		"ISO-10646-UCS-2", /* can't be shortened due to ISO-10646-UCS-Basic */
+		"ISO-10646-UCS-2",
 		"ISO-10646-UCS-4",
-		"UTF-16",		/* covers also BE/LE */
-		"UTF-32",		/* covers also BE/LE */
+		"UTF-16",
+		"UTF-16BE",
+		"UTF-16LE",
+		"UTF-32",
+		"UTF-32BE",
+		"UTF-32LE",
 		"UNICODE-1-1",
 		"SCSU",
 		"csSCSU",
 		NULL };
 	const char **charsetptr = charsets;
-	t_bool ret = FALSE;
 
 	if (!charset)
-		return ret;
+		return TRUE;
 
 	do {
-		if (!strncasecmp(charset, *charsetptr, strlen(*charsetptr)))
+		if (charset_compare(charset, *charsetptr))
 			return TRUE;
 	} while (*(++charsetptr) != NULL);
 
@@ -495,7 +455,7 @@ charset_unsupported(
 
 		if ((cd = iconv_open("UCS-4", charset)) != (iconv_t) (-1)) {
 			iconv_close(cd);
-			return ret;
+			return FALSE;
 		}
 	}
 #	endif /* CHARSET_CONVERSION_ICONV */
@@ -509,14 +469,14 @@ charset_unsupported(
 #if defined(DEBUG) && defined(DEBUG_UCNV)
 			wait_message(2, "UCNV: %s (%s:%d) %s", u_errorName(err), __FILE__, __LINE__, charset);
 #endif /* DEBUG && DEBUG_UCNV */
-			ret = TRUE;
+			return TRUE;
 		} else
 			ucnv_close(test);
 	}
 #	endif /* CHARSET_CONVERSION_UCNV */
 #endif /* CHARSET_CONVERSION */
 
-	return ret;
+	return FALSE;
 }
 
 
@@ -530,7 +490,7 @@ guess_charset(
 	const char *p_match;
 	UCharsetDetector *detector;
 	const UCharsetMatch *match;
-	UErrorCode status = 0;
+	UErrorCode status = U_ZERO_ERROR;
 
 	detector = ucsdet_open(&status);
 	if (U_FAILURE(status))
@@ -570,6 +530,27 @@ failure:
 #endif /* CHARSET_CONVERSION && USE_ICU_UCSDET */
 
 
+void
+csguess_convert_str(
+	char **line,
+	const char *def_cs)
+{
+	size_t len = strlen(*line);
+#ifdef CHARSET_CONVERSION
+#	ifdef USE_ICU_UCSDET
+	char *guessed_charset = guess_charset(*line, 10);
+
+	process_charsets(line, &len, guessed_charset ? guessed_charset : def_cs, tinrc.mm_local_charset, FALSE);
+	FreeAndNull(guessed_charset);
+#	else
+	process_charsets(line, &len, def_cs, tinrc.mm_local_charset, FALSE);
+#	endif /* USE_ICU_UCSDET */
+#else
+	process_charsets(line, &len, def_cs, tinrc.mm_local_charset, FALSE);
+#endif /* CHARSET_CONVERSION */
+}
+
+
 /*
  * restrict it to [a-zA-Z0-9_-]+
  */
@@ -577,11 +558,12 @@ const char *
 validate_charset(
 	const char *charset)
 {
-	const char *c = charset;
+	const char *c;
 
-	if (!charset || strlen(charset) > 40) /* RFC 2978 2.3 */
+	if (!charset || strlen(charset) > CHARSET_MAX_NAME_LEN) /* RFC 2978 2.3 */
 		return NULL;
 
+	c = charset;
 	while (*c) {
 		if (*c < 45 || *c > 122 || *c == 46 || *c == 47 || (*c >= 58 && *c <= 64) || (*c >= 91 && *c <= 94) || *c == 96)
 			return NULL;
@@ -590,3 +572,70 @@ validate_charset(
 	}
 	return charset;
 }
+
+
+/*
+ * compare two charset names ignoring case, punctuation and leading zeros.
+ * returns TRUE if the names do match and FALSE if they differ.
+ *
+ * see Unicode Technical Standard #22, 1.4 Charset Alias Matching
+ * and the note about false positives
+ */
+t_bool
+charset_compare(
+	const char *cs_a,
+	const char *cs_b)
+{
+#ifndef CHARSET_CONVERSION_UCNV
+	int i = 0, j = 0;
+
+	while(cs_a[i] && cs_b[j]) {
+		/* skip all but alnums */
+		while(cs_a[i] && !isalnum((unsigned char) cs_a[i]))
+			i++;
+		while(cs_b[j] && !isalnum((unsigned char) cs_b[j]))
+			j++;
+
+		/* skip 0 not preceded by a digit */
+		while(i && cs_a[i] == '0' && !isdigit((unsigned char) cs_a[i - 1]))
+			i++;
+		while(j && cs_b[j] == '0' && !isdigit((unsigned char) cs_b[j - 1]))
+			j++;
+
+		if (tolower((unsigned char) cs_a[i]) != tolower((unsigned char) cs_b[j]))
+			return FALSE;
+
+		++i;
+		++j;
+	}
+	return TRUE;
+#else
+	if (!ucnv_compareNames(cs_a, cs_b))
+		return TRUE;
+	else
+		return FALSE;
+#endif /* !CHARSET_CONVERSION_UCNV */
+}
+
+
+#if defined(NNTP_ABLE) && defined(CHARSET_CONVERSION) && defined(USE_GSASL)
+/*
+ * return pos. of charset in txt_mime_charsets or -1 if not found
+ */
+int
+charset_name_to_num(
+	const char *charset)
+{
+	int i;
+
+	if (!charset || !*charset)
+		return -1;
+
+	for (i = 0; txt_mime_charsets[i] != NULL; i++) {
+		if (!strcasecmp(charset, txt_mime_charsets[i]))
+			return i;
+	}
+
+	return -1;
+}
+#endif /* NNTP_ABLE && CHARSET_CONVERSION && USE_GSASL */
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/color.c tin-2.6.5/src/color.c
--- tin-2.6.4/src/color.c	2024-11-26 10:39:13.000000000 +0100
+++ tin-2.6.5/src/color.c	2025-12-06 18:38:50.142143848 +0100
@@ -7,11 +7,11 @@
  *              Julien Oster <fuzzy@cu8.cum.de> (word highlighting)
  *              T.Dickey <dickey@invisible-island.net> (curses support)
  *  Created   : 1995-06-02
- *  Updated   : 2023-11-20
+ *  Updated   : 2025-12-06
  *  Notes     : This are the basic function for ansi-color
  *              and word highlighting
  *
- * Copyright (c) 1995-2025 Roland Rosenfeld <roland@spinnaker.rhein.de>
+ * Copyright (c) 1995-2026 Roland Rosenfeld <roland@spinnaker.rhein.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -85,7 +85,7 @@ set_colors(
 	int fcolor,
 	int bcolor)
 {
-	static int nextpair;
+	static int nextpair = 0;
 
 #		ifndef HAVE_USE_DEFAULT_COLORS
 	if (fcolor < 0)
@@ -244,14 +244,14 @@ bcol(
 void
 draw_pager_line(
 	const char *str,
-	int flags,
+	unsigned int flags,
 	t_bool raw_data)
 {
 #ifdef HAVE_COLOR
 	if (use_color) {
 		if (flags & C_SIG) {
 			fcol(tinrc.col_signature);
-		} else if (flags & (C_HEADER | C_ATTACH | C_UUE)) {
+		} else if (flags & (C_HEADER | C_ATTACH | C_UUE | C_YENC)) {
 			fcol(tinrc.col_newsheaders);
 		} else { /* keep order in sync with cook.c:process_text_body_part() */
 			if (flags & C_VERBATIM) {
@@ -301,13 +301,9 @@ draw_pager_line(
 							for (i = 0; i < cCOLS - visual_len - 1; i++)
 								my_fputc(' ', stdout);
 						}
-						my_fputs(line, stdout);
-					} else /* fallback */
-						my_fputs(line, stdout);
-
-				} else	/* LTR */
-					my_fputs(line, stdout);
-
+					}
+				}
+				my_fputs(line, stdout);
 				free(line);
 			} else
 				my_fputs(str, stdout);
@@ -331,10 +327,8 @@ draw_pager_line(
 				c += num_bytes;
 			}
 #else
-			if (my_isprint((unsigned char) *c)) {
-				my_fputc((int) *c, stdout);
-				++c;
-			}
+			if (my_isprint((unsigned char) *c))
+				my_fputc((int) *c++, stdout);
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 			else if (IS_LOCAL_CHARSET("Big5") && (unsigned char) *c >= 0xa1 && (unsigned char) *c <= 0xfe && *(c + 1)) {
 				/*
@@ -342,18 +336,15 @@ draw_pager_line(
 				 * check only for 2-byte chars
 				 * TODO: should we also check if the second byte is also valid?
 				 */
-				my_fputc((int) *c, stdout);
-				++c;
-				my_fputc((int) *c, stdout);
-				++c;
+				my_fputc((int) *c++, stdout);
+				my_fputc((int) *c++, stdout);
 			} else {
 				/*
 				 * non-printable char
 				 * print as an octal value
 				 */
-				snprintf(octal, sizeof(octal), "\\%03o", (unsigned int) (*c & 0xff));
+				snprintf(octal, sizeof(octal), "\\%03o", (unsigned int) (*c++ & 0xff));
 				my_fputs(octal, stdout);
-				++c;
 			}
 		}
 	}
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/config.c tin-2.6.5/src/config.c
--- tin-2.6.4/src/config.c	2024-12-21 15:16:43.000000000 +0100
+++ tin-2.6.5/src/config.c	2025-12-08 20:05:47.448270994 +0100
@@ -3,10 +3,10 @@
  *  Module    : config.c
  *  Author    : I. Lea
  *  Created   : 1991-04-01
- *  Updated   : 2024-12-21
+ *  Updated   : 2025-12-08
  *  Notes     : Configuration file routines
  *
- * Copyright (c) 1991-2025 Iain Lea <iain@bricbrac.de>
+ * Copyright (c) 1991-2026 Iain Lea <iain@bricbrac.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -56,7 +56,7 @@
  */
 static t_bool match_item(const char *line, const char *pat, char *dst, size_t dstlen);
 static t_bool rc_update(FILE *fp);
-static t_bool rc_post_update(FILE *fp/* , struct t_version *upgrade */);
+static t_bool rc_post_update(FILE *fp, const struct t_version *upgrade);
 static void write_server_config(void);
 #ifdef HAVE_COLOR
 	static t_bool match_color(const char *line, const char *pat, int *dst, int max);
@@ -76,12 +76,21 @@ static void write_server_config(void);
 			free(wbuf); \
 		} \
 	} while (0)
+#	define SET_SC_VAL(buf, scval, defval) do { \
+		wchar_t *wbuf; \
+		if ((wbuf = char2wchar_t(buf))) { \
+			wbuf[1] = (wchar_t) '\0'; \
+			scval = !wbuf[0] ? (wchar_t) defval : DASH_TO_SPACE(wbuf[0]); \
+			free(wbuf); \
+		} \
+	} while (0)
 #else
 #	define DASH_TO_SPACE(mark)	((char) (mark == '_' ? ' ' : mark))
 #	define SPACE_TO_DASH(mark)	((char) (mark == ' ' ? '_' : mark))
 #	define SET_RC_VAL(buf, rcval, defval) do { \
 		rcval = !buf[0] ? defval : DASH_TO_SPACE(buf[0]); \
 	} while (0)
+#	define SET_SC_VAL(buf, scval, defval) SET_RC_VAL(buf, scval, defval)
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 
 
@@ -105,12 +114,13 @@ read_config_file(
 	if ((fp = tin_fopen(file, "r")) == NULL)
 		return FALSE;
 
-	if (!batch_mode || verbose)
-		wait_message(0, _(txt_reading_config_file), global_file ? _(txt_global) : "", file);
+	if (/*!batch_mode ||*/ verbose) /* skip message as it would stay on screen after termination */
+		wait_message(0, global_file ? _(txt_reading_global_config_file) : _(txt_reading_config_file), file);
 
 	while ((buf = tin_fgets(fp, FALSE)) != NULL) {
 		if (!*buf)
 			continue;
+
 		if (buf[0] == '#') {
 			if (upgrade == NULL && !global_file && match_string(buf, "# tin configuration file V", NULL, 0)) {
 				upgrade = check_upgrade(buf, "# tin configuration file V", TINRC_VERSION);
